function [vec,kk] = get_features(data, header_data,leads_idx,leads)%get_ECGLeads_features
%     addpath(genpath('dev/'))
    
    %% load extraction parameters
    parameterSTART;
    parameter2DSW;
    parameterCLS;

    SParameter.downsample = NaN;
    SParameter.upsample = NaN;
    AParameter.multiChannel = 0;
    SParameter.convChannel = 2;
    
%    SParameter.w_size = 10; % window size in seconds (calucation of HRV and QTV parameters)
%    SParameter.w_step = 1; % moving window step size in seconds
%    SParameter.metrics = metrics;
    
    WParameter.signal_min = 1;
    WParameter.signal_max = 0;

    AParameter.Plot = 0;
    AParameter.Print = 0;
    AParameter.PrintOut = 0;
    AParameter.Statistik.save2csv = 0;
    AParameter.Statistik.save2mat = 2;
    
    AParameter.DataDir = '';
    AParameter.output_folder = '';
    
    %% start the extraction
    output = struct();
    
    % adjustment for parallelization
    tmp = struct();
    num_leads = length(leads_idx);
    
	parfor i=1:num_leads
%     for i = 1:num_leads
        j = leads_idx(i); %lead-ID
        wp = WParameter;
        ap = AParameter;
        sp = SParameter;
        sp.convChannel = j;
        sp.Channel = j;
        try
            [EMed,EParameter] = WarpSTART_adjusted(data, header_data, wp, ap, sp, leads);
            tmp(i).data = EParameter;
            %tmp(i) = EParameter;
        catch ex
            display(['ch_' num2str(sp.Channel) ': ' getReport(ex)])
            EParameter = errorParameters(data, header_data, ap, sp, leads);
            tmp(i).data = EParameter;
%             tmp(i).data = [];
        end
    end
    
    %tmp = struct(tmp);
    
%     for i = 1:length(tmp_tmp)
%         j = leads_idx_mat(i);
%         tmp(j).data = tmp_tmp;
%     end
% 
%     for i = 1:length(tmp)
%         try
%             output.(tmp(i).data.Lead) = tmp(i).data;
%         end
%     end
    
    for i = 1:length(tmp)
        j = leads_idx(i);
        try
            output.leads(j) = tmp(i).data;
        end
    end
    
    %% build feature vector
    [varnames, varnames_global] = buildFeatureVec(features_numerical, features_numerical_global, features_categorical, features_categorical_global, leads);
%     varnames = {};
%     varnames_global = {};
%     categoricals = {};
% 
%     for i=1:num_leads
%         for j=1:length(features_numerical)
%             varnames{end+1} = [leads{i} '_' features_numerical{j}];
%         end
%         for j=1:length(features_categorical)
%             varnames{end+1} = [leads{i} '_' features_categorical{j}];
%             categoricals = [categoricals, varnames{end}];
%         end
%     end
%     for i=1:length(features_numerical_global)
%         varnames_global{end+1} = features_numerical_global{i};
%     end
%     for i=1:length(features_categorical_global)
%         varnames_global{end+1} = features_categorical_global{i};
%         categoricals = [categoricals, varnames_global{end}];
%     end
    
    % create pre-initialized feature vector; all features are assumed to be numerical
    vec = {};
    for i=1:(length(varnames) + length(varnames_global))
        vec = [vec, NaN]; % init with all being NaN
    end
    
    % fill feature vector
    feat_cnt = 0;
    for k=1:numel(leads)
        % use try catch in case of missing leads or labels
        for l=1:length(features_numerical)
            feat_cnt = feat_cnt + 1;
            try
%                 vec{feat_cnt} = output.(leads{k}).(features_numerical{l});
                vec{feat_cnt} = output.leads(k).(features_numerical{l});
            end
            kk{feat_cnt} = k;
        end
        for l=1:length(features_categorical)
            feat_cnt = feat_cnt + 1;
            try
                vec{feat_cnt} = output.leads(k).(features_categorical{l});
            end
            kk{feat_cnt} = k;
        end
        for l=1:length(features_numerical_global)
            try
                vec{length(varnames) + l} = output.leads(k).(features_numerical_global{l});
            end
            kk{length(varnames) + l} = 0;
        end
        for l=1:length(features_categorical_global)
            try    
                vec{length(varnames) + length(features_numerical_global) + l} = output.leads(k).(features_categorical_global{l});
            end
            kk{length(varnames) + length(features_numerical_global) + l} = 0;
        end
    end
end

